#include "../eSkel.c"
/* Testing global spread farm */
#define PROCS  4 
#define MULT   20  /* each */

#define SEED 234567

int mytopid;
int tasksdone=0;

int *starters;
int *results;

double mpi_start, mpi_end;

double task_start, task_end;

void work (void)
{
  int i;
  register int n;
  int *starter;
  int ndash;
  int one = 1;

  while (starter = Take(&one)) {
    task_start = MPI_Wtime();
    for (i = 0; i<*starter; i++) {
      n = *starter;
      while (n>1) {
        if (n%2) n=3*n+1;
        else n=n/2;
      }
    }
    task_end = MPI_Wtime();
    ndash = n;
    Give(&ndash, 1);
    tasksdone++;
  }
}

int main (int argc, char *argv[])
{
  int i;
  int outmul; 

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &mytopid);
  SkelLibInit();

  starters  = (int *) malloc (sizeof(int)*MULT);
  results   = (int *) malloc (sizeof(int)*MULT);
  for (i=0; i<MULT; i++) {
    starters[i] = SEED + i;
  }
  /* if (mytopid == 0) starters[0] = 1234567; */
  /* Set up all the paraphenalia */
  mpi_start = MPI_Wtime();
  Farm (PROCS, work, myrank(), (void *) starters, 1, MULT, SPLOCAL, MPI_INT,
        (void *) results, 1, &outmul, SPLOCAL, MPI_INT, MULT, mycomm());
  mpi_end = MPI_Wtime();

  for (i=0; i<outmul; i++) {
    if (results[i] != 1) {
      fprintf(stderr,"Dodgy result in P%d - results[%d] is %d\n", mytopid, i, results[i]);
      fflush(stderr);
      exit(0);
    }
  }
  printf("P%d ran %d task(s), seeded %d, in %.2f seconds, task time %.2f seconds\n", mytopid, tasksdone, SEED, mpi_end-mpi_start, task_end-task_start);
  fflush(stdout);
  MPI_Finalize();
  return 0;
}
