#include "../eSkel.c"

/* Testing global spread farm */
#define PROCS  8
#define POINTS 2
#define MULT 10

int mytoppid;

int *displaypoints;
int *displayresults;

void display (int *points, int *results)
{
  int i, j;

  displaypoints  = (int *) malloc (sizeof(int)*POINTS*PROCS);
  displayresults = (int *) malloc (sizeof(int)*POINTS*PROCS);
  if (myrank() == 0) {
    printf("Overall input was \n");
  }

  for (i=0; i<MULT; i++) {
    MPI_Gather(points+i*POINTS,  POINTS, MPI_INT, displaypoints,  POINTS, MPI_INT, 0, MPI_COMM_WORLD);
    if (myrank() == 0) {
      for (j=0; j<POINTS*PROCS; j++) {
         printf("%d ", displaypoints[j]);
      }
      printf(" * ");
    }
  }

  if (myrank() == 0) {
    printf("\n\n\nOverall output was \n");
  }

  for (i=0; i<MULT; i++) {
    MPI_Gather(results+i*POINTS, POINTS, MPI_INT, displayresults, POINTS, MPI_INT, 0, MPI_COMM_WORLD);
    if (myrank() == 0) {
      for (j=0; j<POINTS*PROCS; j++) {
         printf("%d ", displayresults[j]);
      }
      printf(" * ");
    }
  }
  if (myrank() == 0) {
    printf("\n\n\n");
  }
}

eSkel_atom_t *lazyworker(eSkel_atom_t *datum)
{
  int *data;
  int np;
  int i;

  if (datum) {
    data = (int *)(datum->data);
    np = datum->len; 
    for (i=0; i<np; i++) {
      data[i]+=(mytoppid)*100+1;
    }
    return datum;
  } else return NULL;
}


int main (int argc, char *argv[])
{
  int i, j, p, next;
  int *points;
  int *results;
  int outmul;

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &mytoppid);
  SkelLibInit();

  points  = (int *) malloc (sizeof(int)*POINTS*MULT);
  results = (int *) malloc (sizeof(int)*POINTS*MULT);
  for (i=0; i<MULT; i++) {
    for (j=0; j<POINTS; j++) {
      points[i*POINTS+j]  = i;
    }
  }

  /* Set up all the paraphenalia */

  SimpleFarm1for1 (lazyworker, (void *) points, POINTS, MULT, SPGLOBAL, MPI_INT,
                   (void *) results, POINTS, &outmul, SPGLOBAL, MPI_INT, 
                   POINTS*MULT, mycomm());

  display(points, results);
  MPI_Finalize();
  return 0;
}
