#include "../eSkel.c"

/* Testing local spread pipeline */


#define P 8
#define N 100

int *myprime;

void generator (void)
{
  int i;
  int next = 2;
  
  while (next < N) {
    Give(&next, 1);
    next++;
  }
}

void sieve (void)
{
  int *cand, count;

  count = 1;
  myprime = Take (&count);
  while (count = 1, cand = Take (&count)) {
    if ((*cand)% (*myprime)) Give (cand, 1);        
  }
}

void lastsieve (void)
{
  int *cand, count=1;

  myprime = Take (&count);
  while (cand = Take (&count)) {
    ;
  }
}

int main (int argc, char *argv[])
{
  spread_t spreads[P+1];
  MPI_Datatype types[P+1];
  int outmul;
  void (*stages[P])(void);

  int i;

  MPI_Init(&argc, &argv);
  SkelLibInit();

  stages[0] = (void (*) (void))    generator;
  for (i=1; i<P-1; i++) {
    stages[i] = (void (*) (void))  sieve;
  }
  stages[P-1] = (void (*) (void))  lastsieve;

  for (i=0; i<P+1; i++) {
    spreads[i] = SPLOCAL;
    types[i]   = MPI_INT;
  }
  outmul = 0;

  Pipeline (P, stages, myrank(), spreads, types, NULL, 0, 0, NULL, 0, &outmul, 0, mycomm());

  for (i=0; i<P; i++) {
    MPI_Barrier(MPI_COMM_WORLD);
    if (myrank() == i) {
      if (myrank() > 0) 
        printf("Process %d found %d\n", myrank(), *myprime);
      else printf("Process 0 was the generator\n");
    }
  }
  MPI_Finalize();
  return 0;
}
