#include "../eSkel.c"
#define P 4 
#define MULT   5  /* each */

#define SEED 234567

int mytopid;
int tasksdone=0;

int *tasks;
int *ulam;
int *allulam;

double mpi_start, mpi_end;

double task_start, task_end;

void work (void)
{
  int i, n;
  int *task;
  int iters;
  int one = 1;

  while (task = Take(&one)) {
    task_start = MPI_Wtime();
    n = *task;
    iters = 0;
    while (n>1) {
      if (n%2) n=3*n+1;
      else n=n/2;
      iters++;
    }
    task_end = MPI_Wtime();
    Give(&iters, 1);
    tasksdone++;
  }
}

int main (int argc, char *argv[])
{
  int i;
  int outmul; 

  MPI_Init(&argc, &argv);
  MPI_Comm_rank(MPI_COMM_WORLD, &mytopid);
  SkelLibInit();

  tasks  = (int *) malloc (sizeof(int)*MULT);
  ulam   = (int *) malloc (sizeof(int)*MULT);
  for (i=0; i<MULT; i++) {
    tasks[i] = myrank()*MULT + i + 1;
  }

  mpi_start = MPI_Wtime();
  Farm (P, work, myrank(), (void *) tasks, 1, MULT, SPLOCAL, MPI_INT,
        (void *) ulam, 1, &outmul, SPLOCAL, MPI_INT, MULT, mycomm());
  mpi_end = MPI_Wtime();

  if (myrank() == 0) {
    allulam = (int *) malloc (sizeof(int)*MULT*P);
  }
 
  MPI_Gather (ulam, MULT, MPI_INT, allulam, MULT, MPI_INT, 0, MPI_COMM_WORLD);
 
  if (myrank() == 0) {
    printf("\nUlam values: ");
    for (i=0; i<MULT*P; i++) {
      printf ("%d ", allulam[i]);
    }
    printf("\n");
  }

  printf("P%d ran %d task(s), seeded %d, in %.2f seconds, task time %.2f seconds\n", mytopid, tasksdone, SEED, mpi_end-mpi_start, task_end-task_start);
  fflush(stdout);
  MPI_Finalize();
  return 0;
}
