void FarmGive (void *out, int len)
{
   /* Just stick it in the output buffer for subsequent collection */
   FrStack[Top]->context.f.outblens[FrStack[Top]->context.f.outbcount] = len;
   FrStack[Top]->context.f.outbtags[FrStack[Top]->context.f.outbcount]  = FrStack[Top]->context.f.currenttag;
   FrStack[Top]->context.f.outbuff[FrStack[Top]->context.f.outbcount] = 
     (char *) malloc (len*FrStack[Top]->context.f.outsz);
   memcpy((void *) FrStack[Top]->context.f.outbuff[FrStack[Top]->context.f.outbcount], 
          (char *) out, len*FrStack[Top]->context.f.outsz);
   FrStack[Top]->context.f.outbcount++;
}

void *FarmTake (int *items)
{
   MPI_Status stat;
   int junk, totallen;
   char *tempbuff;
   void *takeptr;

   if (FrStack[Top]->myrank == 0) {
     /* intended for the farmer thread on parent proc 0 */
     MPI_Send(NULL, 0, MPI_BYTE, 0, FARMTAKETAG, FrStack[Top]->context.f.tofarmercomm);
     if (FrStack[Top]->context.f.inspr == SPGLOBAL) {
        MPI_Recv(&totallen, 1, MPI_INT, 0, MPI_ANY_TAG, FrStack[Top]->context.f.fromfarmercomm, &stat);
        if (stat.MPI_TAG==SHUTDOWNTAG) {
          junk = SHUTDOWNTAG;
          MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
          return NULL;
        } else {
          tempbuff = (char *) malloc(FrStack[Top]->context.f.insz*totallen);
          MPI_Recv(tempbuff, totallen, FrStack[Top]->context.f.inty,
                   0, MPI_ANY_TAG, FrStack[Top]->context.f.fromfarmercomm, &stat);
          MPI_Recv(&(FrStack[Top]->context.f.currenttag), 1, MPI_INT, 0, 
                   MPI_ANY_TAG, FrStack[Top]->context.f.fromfarmercomm, &stat);
          junk = NOSHUTDOWNTAG;
          MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
          /* now scatter the data */
          *items = -1;
          Glob_Unit_Scatter (mycomm(), mycommsize(), myrank(), 0, FrStack[Top]->context.f.inty, 
                             FrStack[Top]->context.f.insz,
                             (void *) tempbuff, totallen,         
                             (char **) &takeptr, items);
          return takeptr;
        }
     } else  if (FrStack[Top]->context.f.inspr == SPLOCAL) {
        MPI_Recv(&totallen, 1, MPI_INT, 0, MPI_ANY_TAG, FrStack[Top]->context.f.fromfarmercomm, &stat);
        if (stat.MPI_TAG==SHUTDOWNTAG) {
          /* broadcast shutdown tag to other stage members */       
          junk = SHUTDOWNTAG;
          MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
          return NULL;
        } else { 
          MPI_Probe(MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[Top]->context.f.fromfarmercomm, &stat);
          MPI_Get_count(&stat, FrStack[Top]->context.f.inty, items);
          takeptr = (void *) malloc (FrStack[Top]->context.f.insz* (*items));
          MPI_Recv(takeptr, *items, FrStack[Top]->context.f.inty,  
                   MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[Top]->context.f.fromfarmercomm, &stat);
          /* get source tag then broadcast noshutdown tag to other stage members */       
          MPI_Recv(&(FrStack[Top]->context.f.currenttag), 1, MPI_INT, MPI_ANY_SOURCE, 
                   MPI_ANY_TAG, FrStack[Top]->context.f.fromfarmercomm, &stat);
          junk = NOSHUTDOWNTAG;
          MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
          return takeptr;
        }
     }
   } else /* not the root of the worker */ {
     if (FrStack[Top]->context.f.inspr == SPGLOBAL) {
        MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
        if (junk == SHUTDOWNTAG) return FALSE;
        *items = -1;
 	Glob_Unit_Scatter (mycomm(), mycommsize(), myrank(), 0, FrStack[Top]->context.f.inty, 
            	           FrStack[Top]->context.f.insz, NULL, 0, (char **) &takeptr, items);
        return takeptr;
     } else  if (FrStack[Top]->context.f.inspr == SPLOCAL) {
       MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
       return (junk!=SHUTDOWNTAG ? &somewhere : NULL);
     }
   }
}

