/* Basic idea - simple implementation. farmer0 gathers the necessary data from other  */
/* farmers (whether local or global) then scatters it across the requesting group.    */
/* Initially, farmer 0 gathers all input (!!!) to itself. This is grotesque and       */
/* must be improved upon later. This is implemented within the Farm function itself   */
/* for now, but could be a farmer activity later                                      */
/* It also means that, for now, we only need a farmer thread on comm P0               */
/*                                                                                    */
/* Farmer 0 loops, accepting Take requests from worker0s and either                   */
/*     - responding, while stuff remains                                              */
/*       SPEITHER: send only worker0 the stuff                                        */
/*     - returning "no more" when this is is the case                                 */
/*       SPEITHER : send only worker0 the SHUTDOWNTAG                                 */
/* until all workers have been told "no more" at which point it tells the other       */
/* farmers to quit before quitting itself                                             */
/* Other farmers therefore only interact with farmer 0, waiting to be told either to  */
/* send the next thing, or to shutdown.                                               */


/* In this implementation only exists on Farm process 0, charged with accepting */
/* Take requests from worker roots and responding as described above.           */
void farmerthr (int *dontcarefornow) 
{
  int i, j;

  int shutdowncount = 0;     /* How many workers have I told to shutdown           */
                             /* Assume workers behave - could enforce this in Take */
  MPI_Status status;
  int wroot;                 /* root id of the requesting worker */
  int target;
  int junk;

  while (shutdowncount < FrStack[Top]->context.f.w) {
    MPI_Recv(NULL, 0, MPI_BYTE, MPI_ANY_SOURCE, FARMTAKETAG, FrStack[Top]->context.f.tofarmercomm, &status);
    wroot = status.MPI_SOURCE;
    if (FrStack[Top]->context.f.inbnext < FrStack[Top]->context.f.allinmul) {
      /* send out the next item, all to the worker root */
      MPI_Send (&(FrStack[Top]->context.f.inblens[FrStack[Top]->context.f.inbnext]), 1, 
                MPI_INT, wroot, NOSHUTDOWNTAG, FrStack[Top]->context.f.fromfarmercomm); 
      MPI_Send (FrStack[Top]->context.f.inbuff[FrStack[Top]->context.f.inbnext], 
                FrStack[Top]->context.f.inblens[FrStack[Top]->context.f.inbnext],
                FrStack[Top]->context.f.inty, 
                wroot, NOSHUTDOWNTAG, FrStack[Top]->context.f.fromfarmercomm); 
      /* Now send a source item tag */
      MPI_Send (&(FrStack[Top]->context.f.inbnext), 1, MPI_INT, wroot, NOSHUTDOWNTAG, FrStack[Top]->context.f.fromfarmercomm); 
      FrStack[Top]->context.f.inbnext++;
    } else {
      /* send the SHUTDOWNTAG to the worker root only */
      MPI_Send (&junk, 1, MPI_INT, wroot, SHUTDOWNTAG, FrStack[Top]->context.f.fromfarmercomm); 
      shutdowncount++;
    }
  }
}


void Farmv (int nw, void worker(void), int col, 
           void *in,  int *inlen, int inmul, spread_t inspr, MPI_Datatype inty, 
           void *out, int *outlen, int *outmul, spread_t outspr, MPI_Datatype outty, MPI_Comm comm)
{
  MPI_Status stat;
  int *allcols;           /* note of nominated colour for each process */
  pthread_t farmerthread;  
  void * farmerretval;    /* find out what this is actually about ! */
  char *sndptr;

  char **woutbuff;        /* on worker root, for gathering the workers results           */
  int  woutmult;          /* just a convenient copy of final outbnext on the worker root */
  int  *woutlens;
                          /* the tags are already on the worker root,  for either spread */     


  char **foutbuff;        /* on comm root only, for gathering all results before final scatter */
  int  foutmult;
  int  *foutlens;
  int  *fouttags;

  int onewmult;
  int i, j, k, next;

  char * rcvptr;
  int outbuffspaceleft;
  int outbufflensspaceleft;

  int *tempptr;

  int things[2];  /* just in debugging */

  int temp;

  Top++;
  FrStack[Top] = (skel_t *) malloc (sizeof(skel_t));
  FrStack[Top]->skel = Fskel;
  FrStack[Top]->context.f.parentcomm = comm;
  MPI_Comm_size(comm, &FrStack[Top]->context.f.parentcommsize);
  MPI_Comm_rank(comm, &FrStack[Top]->context.f.parentcommrank);

  MPI_Comm_dup (comm, &FrStack[Top]->context.f.tofarmercomm);

  MPI_Comm_dup (comm, &FrStack[Top]->context.f.fromfarmercomm);

  FrStack[Top]->context.f.inspr      = inspr;  
  FrStack[Top]->context.f.inty       = inty;   
  MPI_Type_size(inty, &FrStack[Top]->context.f.insz);

  FrStack[Top]->context.f.outspr      = outspr;  
  FrStack[Top]->context.f.outty       = outty;   
  MPI_Type_size(outty, &FrStack[Top]->context.f.outsz);

  /* calculate the worker groups and note                                */
  /*  - all group members and their roots, all as upper ids in comm      */
  /*  - do this on all comm processes, even though in the current impl.  */
  /*    only comm0 will need to know                                     */
  FrStack[Top]->context.f.w = nw;
  FrStack[Top]->context.f.wsz = (int *) malloc (sizeof(int)*nw);
  FrStack[Top]->context.f.wids = (int **) malloc (sizeof(int *)*nw);
  allcols = (int *) malloc (sizeof(int)*FrStack[Top]->context.f.parentcommsize);
  MPI_Allgather((void *) &col, 1, MPI_INT, (void *) allcols, 1, MPI_INT, comm);
  for (i=0; i<nw; i++) {
    FrStack[Top]->context.f.wsz[i] = 0;
  }
  for (i=0; i<FrStack[Top]->context.f.parentcommsize; i++) {
    FrStack[Top]->context.f.wsz[allcols[i]]++;
  }
  for (i=0; i<nw; i++) {
    FrStack[Top]->context.f.wids[i] = (int *) (malloc(sizeof(int)* FrStack[Top]->context.f.wsz[i]));
  }

  tempptr = (int *) malloc (sizeof(int)*nw);  /* just for indexing into the worker member lists */
  for (i=0; i<nw; i++) {
    tempptr[i] = 0;
  }
  for (i=0; i<FrStack[Top]->context.f.parentcommsize; i++) {
    FrStack[Top]->context.f.wids[allcols[i]][tempptr[allcols[i]]++] = i;
  }
  free(tempptr);

  /* split off comms for the worker groups */
  MPI_Comm_split(comm, col, 0, &FrStack[Top]->mycomm);
  MPI_Comm_rank(FrStack[Top]->mycomm, &FrStack[Top]->myrank);
  MPI_Comm_size(FrStack[Top]->mycomm, &FrStack[Top]->mycommsize);

  /* gather all the input data into the inbuff on P0 - a better imp would distribute this */
  if (FrStack[Top]->context.f.inspr == SPGLOBAL) {
    if (FrStack[Top]->context.f.parentcommrank == 0) {
      FrStack[Top]->context.f.inblens = (int *) malloc (sizeof(int) * inmul);
      FrStack[Top]->context.f.inbuff  = (char **) malloc (sizeof(char *)*inmul);
    }
    sndptr = (char *) in;
    for (i=0; i<inmul; i++) {
      if (FrStack[Top]->context.f.parentcommrank == 0) {
        FrStack[Top]->context.f.inblens[i] = -1;
        Glob_Unit_Gather (comm, FrStack[Top]->context.f.parentcommsize, 
                          FrStack[Top]->context.f.parentcommrank,
                          0, FrStack[Top]->context.f.inty, FrStack[Top]->context.f.insz,
                          sndptr, inlen[i], 
                          &(FrStack[Top]->context.f.inbuff[i]), &FrStack[Top]->context.f.inblens[i]);
      } else {
        Glob_Unit_Gather (comm, FrStack[Top]->context.f.parentcommsize, 
                          FrStack[Top]->context.f.parentcommrank,
                          0, FrStack[Top]->context.f.inty, FrStack[Top]->context.f.insz,
                          sndptr, inlen[i], NULL, NULL);
      }
      sndptr = sndptr + (FrStack[Top]->context.f.insz * inlen[i]);
    }
    FrStack[Top]->context.f.inbnext = 0;      /* set up "pointer" for Take */
    FrStack[Top]->context.f.allinmul = inmul; /* probably shouldn't look at this anyway for SPGLOBAL */
  } else if (FrStack[Top]->context.f.inspr == SPLOCAL) {
    Local_Mult_Gather (comm, FrStack[Top]->context.f.parentcommsize, FrStack[Top]->context.f.parentcommrank,
                       0, FrStack[Top]->context.f.inty, FrStack[Top]->context.f.insz,
                       in, inmul, inlen,
                       &FrStack[Top]->context.f.inbuff, &FrStack[Top]->context.f.allinmul,
                       &FrStack[Top]->context.f.inblens);
    FrStack[Top]->context.f.inbnext = 0; /* set up "pointer" for Take */
  }

  /*  set up the outbuffs in each worker */
  if (inspr == SPGLOBAL) {
      FrStack[Top]->context.f.outblens = (int *)  malloc (sizeof(int)*MAXOUTMUL);
      FrStack[Top]->context.f.outbtags = (int *)  malloc (sizeof(int)*MAXOUTMUL);
      FrStack[Top]->context.f.outbuff  = (char **)malloc (sizeof(char *)*MAXOUTMUL);
      FrStack[Top]->context.f.outbcount = 0;
  } else if (inspr == SPLOCAL) {
    if (FrStack[Top]->myrank == 0) {
      FrStack[Top]->context.f.outblens = (int *)  malloc (sizeof(int)*MAXOUTMUL);
      FrStack[Top]->context.f.outbtags = (int *)  malloc (sizeof(int)*MAXOUTMUL);
      FrStack[Top]->context.f.outbuff  = (char **)malloc (sizeof(char *)*MAXOUTMUL);
      FrStack[Top]->context.f.outbcount = 0;
    }
  }


  /* spark the farmer thread on comm P0*/
  /* a more distributed implementation would require farmer threads on all comm processes */
  if (FrStack[Top]->context.f.parentcommrank == 0) {
    pthread_create(&farmerthread, NULL,  (void* (*) (void *))&farmerthr, NULL);
  }
  /* call the workers, implicitly in lower comm */
  worker();
  /* wait for farmer thread to quit (and do we need a barrier here ?) */
  if (FrStack[Top]->context.f.parentcommrank == 0) {
    pthread_join(farmerthread, &farmerretval);
  }
  MPI_Barrier(comm);                      /* Think hard about whether we really need this */

  /* gather/scatter the results from lower to upper level */
  /* this is why Given items need to be tagged with their Take item id*/
  
  /* 
        in each worker group
         if (SPGLOBAL)
          gather all results to the worker root
          gather corresponding tags 
         else root has all this already when SPLOCAL
  */

  if (inspr == SPGLOBAL) {
    woutmult = FrStack[Top]->context.f.outbcount; /* copy for convenience only */
    if (FrStack[Top]->myrank == 0) {
      woutbuff = (char **) malloc (sizeof(char *)*  woutmult);
      woutlens = (int *) malloc   (sizeof(int) *    woutmult);
    }
    for (i=0; i<woutmult; i++) {
      if (FrStack[Top]->myrank == 0) {
        woutlens[i] = -1;
        Glob_Unit_Gather (mycomm(), mycommsize(), myrank(),
                          0, outty, FrStack[Top]->context.f.outsz,
                          (void *)FrStack[Top]->context.f.outbuff[i], 
                          FrStack[Top]->context.f.outblens[i], &woutbuff[i], 
                          &woutlens[i]);
      } else {
        Glob_Unit_Gather (mycomm(), mycommsize(), myrank(),
                          0, outty, FrStack[Top]->context.f.outsz,
                          (void *)FrStack[Top]->context.f.outbuff[i], 
                          FrStack[Top]->context.f.outblens[i], NULL, 
                          NULL);
      }
    /* no need to gather tags, we have them already on the worker root */
    }
  } else if (inspr == SPLOCAL) {
    woutmult = FrStack[Top]->context.f.outbcount; /* copy for convenience only                 */
    woutbuff = FrStack[Top]->context.f.outbuff;   /* already have all the data in outbuff      */
    woutlens = FrStack[Top]->context.f.outblens;  /* so just point to it                       */
  }

  /*   
       for each worker root
          for each result
            send result&tag to the farm root
  */

  if (FrStack[Top]->context.f.parentcommrank == 0) { /* farm root, and by implication a worker root) */
    /* Count overall mult and set up data structure */
    MPI_Reduce (&woutmult, &foutmult, 1, MPI_INT, MPI_SUM, 0, comm);
    foutbuff = (char **) malloc (sizeof(char *) * foutmult);
    foutlens = (int *) malloc   (sizeof(int)    * foutmult);
    fouttags = (int *) malloc   (sizeof(int)    * foutmult);
    next=0;
    for (i=0; i<FrStack[Top]->context.f.w; i++) {
      if (FrStack[Top]->context.f.wids[i][0] != 0) {
          MPI_Recv(&onewmult, 1, MPI_INT, FrStack[Top]->context.f.wids[i][0], MPI_ANY_TAG, comm, &stat);
          for (j=0; j<onewmult; j++) {
            MPI_Recv(&foutlens[next], 1, MPI_INT, FrStack[Top]->context.f.wids[i][0], MPI_ANY_TAG, comm, &stat);
            foutbuff[next] = (char *) malloc (FrStack[Top]->context.f.outsz*foutlens[next]);
            MPI_Recv(foutbuff[next], foutlens[next], outty, FrStack[Top]->context.f.wids[i][0], MPI_ANY_TAG, comm, &stat); 
            MPI_Recv(&fouttags[next], 1, MPI_INT,  FrStack[Top]->context.f.wids[i][0], MPI_ANY_TAG, comm, &stat);
            next++;
          }
      } else { /* get my own (ie farm root) worker contributions */
  	  onewmult = woutmult;
          for (j=0; j<onewmult; j++) {
            foutlens[next] = woutlens[j];
            foutbuff[next] = (char *) malloc (FrStack[Top]->context.f.outsz*foutlens[next]);
            memcpy (foutbuff[next], woutbuff[j], FrStack[Top]->context.f.outsz*foutlens[next]);
            fouttags[next] = FrStack[Top]->context.f.outbtags[j];
            next++;
          }
      }
    }
  } else if (FrStack[Top]->myrank == 0) {  /* just a worker root */
    MPI_Reduce (&woutmult, &foutmult, 1, MPI_INT, MPI_SUM, 0, comm);
    MPI_Send (&woutmult, 1, MPI_INT, 0, 0, comm); 
    for (j=0; j < woutmult; j++) {
      MPI_Send(&woutlens[j], 1, MPI_INT, 0, 0, comm);
      MPI_Send(woutbuff[j], woutlens[j], outty, 0, 0, comm); 
      MPI_Send(&FrStack[Top]->context.f.outbtags[j], 1, MPI_INT, 0, 0, comm);
    }
  } else { /* neither worker nor farmer root, just playing along for synch, add zero to count */
    MPI_Reduce (&zero, &foutmult, 1, MPI_INT, MPI_SUM, 0, comm);
  }

  /* farmer root sorts outputs by tag (stably wrt generated order per tag) */
  if (FrStack[Top]->context.f.parentcommrank == 0) {
    stable_sort_by_tag(foutmult, fouttags, (int **)foutbuff, foutlens);
  }


  /*  And finally .............
       if SPGLOBAL
         for each output
          GlobalUnitScatter the output across the real out buffers            
       else SPLOCAL
         Local_Mult Scatter the outputs
   */

  if (outspr == SPGLOBAL) {
    rcvptr = (char *) out;
    outbuffspaceleft     = outlen[0];
    outbufflensspaceleft = outlen[1];
    /* broadcast actual multiplicity of output */
    MPI_Bcast(&foutmult, 1, MPI_INT, 0, comm);
    for (i=0; i< foutmult; i++) {
      temp = outbuffspaceleft;
      if (FrStack[Top]->context.f.parentcommrank == 0) {
        Glob_Unit_Scatter (comm, FrStack[Top]->context.f.parentcommsize, 
                           FrStack[Top]->context.f.parentcommrank, 
                           0, outty, FrStack[Top]->context.f.outsz,
                           (void *) foutbuff[i], foutlens[i], &rcvptr, &temp);
      } else {
        Glob_Unit_Scatter (comm, FrStack[Top]->context.f.parentcommsize, 
                           FrStack[Top]->context.f.parentcommrank, 
                           0, outty, FrStack[Top]->context.f.outsz,
                           NULL, 0, &rcvptr, &temp);
      }
      outbuffspaceleft -= temp;
      if (i<outbufflensspaceleft) {
        outlen[i] = temp;
      } else {
       fprintf(stderr, "No more space for farm outbufflens\n");
       exit(0);
      }
      rcvptr += (temp*FrStack[Top]->context.f.outsz);
    }
    *outmul = foutmult;
  } else {
    /* distribute local spread results */
    Local_Mult_Scatter (comm, FrStack[Top]->context.f.parentcommsize, FrStack[Top]->context.f.parentcommrank,
                        0, outty, FrStack[Top]->context.f.outsz,
                        (void **) foutbuff, foutmult, 
                        foutlens, (char *) out, outmul, outlen);
  }

  Top--;
  return;
}

