void PipeGive (void *out, int len)
{
  int  *inlens;
  int  *indisp;
  char *givebuff;
  char *sndptr;
  int  gtysz;
  int i;
  int thissz;
  int totallen;

  if (FrStack[Top]->context.p.spr[FrStack[Top]->context.p.mystage+1] == SPGLOBAL) {
    if (len == SHUTDOWNLEN) {
      /* pass on the shut down message */
      if (FrStack[Top]->myrank == 0) {
        for (i=0; i<FrStack[Top]->context.p.nextstagesize; i++) {
	  MPI_Send(NULL, 0, MPI_INT, 
  	           FrStack[Top]->context.p.nextstage[i], SHUTDOWNTAG, FrStack[Top]->context.p.parentcomm);
        }
      }
      return;
    }
    if (FrStack[Top]->context.p.mystage == FrStack[Top]->context.p.ns-1) {
      /* last stage so just buffer it for later collection */
      FrStack[Top]->context.p.poutblens[FrStack[Top]->context.p.poutbnext] = len;
      FrStack[Top]->context.p.poutbuff[FrStack[Top]->context.p.poutbnext] = 
        (char *) malloc (len*FrStack[Top]->context.p.itemsz[FrStack[Top]->context.p.mystage+1]);
      memcpy((void *) FrStack[Top]->context.p.poutbuff[FrStack[Top]->context.p.poutbnext], 
             (char *) out, len*FrStack[Top]->context.p.itemsz[FrStack[Top]->context.p.mystage+1]);
      FrStack[Top]->context.p.poutbnext++;
    } else {
      /* other stage, so interact with next stage */
      /* first indicate that this is a real transfer */
      if (FrStack[Top]->myrank == 0) {
        for (i=0; i<FrStack[Top]->context.p.nextstagesize; i++) {
           MPI_Send(NULL, 0, MPI_INT,
                    FrStack[Top]->context.p.nextstage[i], NOSHUTDOWNTAG, FrStack[Top]->context.p.parentcomm);
        }
      }
      /* and then send the stuff */
      group2group (FrStack[Top]->context.p.parentcomm, FrStack[Top]->context.p.parentcommsize,
                   FrStack[Top]->context.p.parentcommrank, SENDER,  FrStack[Top]->myrank,
                   FrStack[Top]->context.p.thisstagecomm,  FrStack[Top]->mycommsize,  
                   FrStack[Top]->context.p.thisstage,
                   MPI_COMM_NULL, FrStack[Top]->context.p.nextstagesize, 
                   FrStack[Top]->context.p.nextstage,
                   FrStack[Top]->context.p.ty[FrStack[Top]->context.p.mystage+1], 
                   FrStack[Top]->context.p.itemsz[FrStack[Top]->context.p.mystage+1],
                   out, len, NULL, NULL);
    }
  } else if (FrStack[Top]->context.p.spr[FrStack[Top]->context.p.mystage+1] == SPLOCAL) {
    if (FrStack[Top]->myrank == 0) {  /* I am the root of the stage */
      if (len == SHUTDOWNLEN) {
        /* pass on the shutdown message */
        MPI_Send(NULL, 0,  FrStack[Top]->context.p.ty[FrStack[Top]->context.p.mystage+1],
                 FrStack[Top]->context.p.nextstage[0], SHUTDOWNTAG, FrStack[Top]->context.p.parentcomm);
        return;
      }

      if (FrStack[Top]->context.p.mystage == FrStack[Top]->context.p.ns-1) {
        /* last stage so buffer it until later */
        FrStack[Top]->context.p.poutblens[FrStack[Top]->context.p.poutbnext] = len;
        FrStack[Top]->context.p.poutbuff[FrStack[Top]->context.p.poutbnext] = 
          (char *) malloc (len*FrStack[Top]->context.p.itemsz[FrStack[Top]->context.p.mystage+1]);
        memcpy((void *) FrStack[Top]->context.p.poutbuff[FrStack[Top]->context.p.poutbnext], 
               (char *) out, len*FrStack[Top]->context.p.itemsz[FrStack[Top]->context.p.mystage+1]);
        FrStack[Top]->context.p.poutbnext++;
      } else {
	/* Send the item from the root of this stage to the root of the next, via the parent comm */
        MPI_Send(out, len,  FrStack[Top]->context.p.ty[FrStack[Top]->context.p.mystage+1],
                 FrStack[Top]->context.p.nextstage[0], NOSHUTDOWNTAG,  FrStack[Top]->context.p.parentcomm);
      }
    }
  }
}

void *PipeTake (int *items)
{
   MPI_Status stat;
   int junk, totallen;
   char *tempbuff;
   void *takeptr;

   if (FrStack[Top]->context.p.spr[FrStack[Top]->context.p.mystage] == SPGLOBAL) {
     if (FrStack[Top]->context.p.shutdown) {
       printf("Trying to Take after shutdown....\n");
       exit(0);
     }
     if (FrStack[Top]->context.p.mystage == 0) {
       /* get it from my buffer or return FALSE if buffer is empty and set shutdown = TRUE  */
       if (FrStack[Top]->context.p.bnext == FrStack[Top]->context.p.inmul) {
         FrStack[Top]->context.p.shutdown = TRUE;
         return NULL;
       }
       *items  = FrStack[Top]->context.p.blens[FrStack[Top]->context.p.bnext];
       takeptr = (void *) malloc (FrStack[Top]->context.p.itemsz[0] * (*items));
       memcpy(takeptr, FrStack[Top]->context.p.buff[FrStack[Top]->context.p.bnext], 
              FrStack[Top]->context.p.itemsz[0]* (*items));
       FrStack[Top]->context.p.bnext++;
       return takeptr;
     } else {
       /* other stage so interact with previous stage */
       MPI_Recv(&junk, 1, MPI_INT, MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[Top]->context.p.parentcomm, &stat);
       if (stat.MPI_TAG==SHUTDOWNTAG) {
         FrStack[Top]->context.p.shutdown = TRUE; 
         return NULL;
       }
       /* get the stuff */
       *items = -1;
       group2group (FrStack[Top]->context.p.parentcomm, FrStack[Top]->context.p.parentcommsize,
                    FrStack[Top]->context.p.parentcommrank, RECEIVER,  FrStack[Top]->myrank,
                    MPI_COMM_NULL,  FrStack[Top]->context.p.prevstagesize,  
                    FrStack[Top]->context.p.prevstage,
                    FrStack[Top]->mycomm, FrStack[Top]->mycommsize, 
                    FrStack[Top]->context.p.thisstage,
                    FrStack[Top]->context.p.ty[FrStack[Top]->context.p.mystage], 
                    FrStack[Top]->context.p.itemsz[FrStack[Top]->context.p.mystage],
                    NULL, 0, (char **) &takeptr, items);
       return takeptr;
     }
   } else if (FrStack[Top]->context.p.spr[FrStack[Top]->context.p.mystage] == SPLOCAL) {
     if (FrStack[Top]->context.p.shutdown) {
       printf("Trying to Take after shutdown....\n");
       exit(0);
     }
     if (FrStack[Top]->myrank == 0) {  /* I am the root of the stage */
       if (FrStack[Top]->context.p.mystage == 0) {
         /* get it from my buffer or return FALSE if buffer is empty and set shutdown = TRUE  */
         if (FrStack[Top]->context.p.bnext == FrStack[Top]->context.p.inmul) {
           /* broadcast shutdown tag to other stage members */       
           junk = SHUTDOWNTAG;
           MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
           FrStack[Top]->context.p.shutdown = TRUE;
           return NULL;
         }
         *items = FrStack[Top]->context.p.blens[FrStack[Top]->context.p.bnext];
         takeptr = (void *) malloc (FrStack[Top]->context.p.itemsz[0]* (*items));
         memcpy(takeptr, FrStack[Top]->context.p.buff[FrStack[Top]->context.p.bnext], 
                FrStack[Top]->context.p.itemsz[0]* (*items));
         FrStack[Top]->context.p.bnext++;
         /* broadcast noshutdown tag to other stage members */       
         junk = NOSHUTDOWNTAG;
         MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
         return takeptr;
       } else {
 	  /* just receive the whole thing directly from the preceding root */ 
	 MPI_Probe(MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[Top]->context.p.parentcomm, &stat);
         if (stat.MPI_TAG==SHUTDOWNTAG) {
           /* receive the "message" */
           takeptr = (void *) malloc (FrStack[Top]->context.p.itemsz[0]* 1);  /* dummy */
           MPI_Recv(takeptr, 1, FrStack[Top]->context.p.ty[FrStack[Top]->context.p.mystage],  
                  MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[Top]->context.p.parentcomm, &stat);
           /* broadcast shutdown tag to other stage members */       
           junk = SHUTDOWNTAG;
           MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
           FrStack[Top]->context.p.shutdown = TRUE; 
           return NULL;
         } else {
           MPI_Get_count(&stat, FrStack[Top]->context.p.ty[FrStack[Top]->context.p.mystage], items);
           takeptr = (void *) malloc (FrStack[Top]->context.p.itemsz[0]* (*items));
           MPI_Recv(takeptr, *items, FrStack[Top]->context.p.ty[FrStack[Top]->context.p.mystage],  
                  MPI_ANY_SOURCE, MPI_ANY_TAG, FrStack[Top]->context.p.parentcomm, &stat);
           junk = NOSHUTDOWNTAG;
           MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
           return takeptr;
         }
       }
     } else {
       /* I'm not the stage root, so just get the shutdown indicator from the stage root */
       MPI_Bcast (&junk, 1, MPI_INT, 0, FrStack[Top]->mycomm);
       if (junk==SHUTDOWNTAG) {
          FrStack[Top]->context.p.shutdown = TRUE; 
          return NULL;
       } else {
	 return &somewhere;  /* horrific hack */
       }
     }
   }
}

